<%@ Application Language=C# Codebehind="Global.asax.cs" Inherits="Rainbow.Global" %>
<%@ Import Namespace="Rainbow.Security" %>
<%@ Import Namespace="Rainbow.Settings" %>
<%@ Import Namespace="Rainbow.Configuration" %>
<%@ Import Namespace="CuteChat" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<script runat=server>


public override void Init()
{
	base.Init();

	if(ChatSystem.HasStarted)return;

	ChatProvider.Instance = new RainbowChatProvider();
	ChatSystem.Start(new AppSystem());

}

static public int PortalID
{
	get
	{
		return 1;
	}
}

public class RainbowChatProvider : ChatProvider
{
	public override string GetConnectionString()
	{
		return System.Configuration.ConfigurationSettings.AppSettings["ConnectionString"];
	}


	public string GetUserUniqueName()
	{
		if(!HttpContext.Current.User.Identity.IsAuthenticated)
		{
			return null;
		}

		string userdata=HttpContext.Current.User.Identity.Name;
		string[] parts=userdata.Split('|');
		if(parts.Length!=3)
		{
			return null;
		}
		//name|email|id

		int userid=int.Parse(parts[2]);
		if(userid==0)
			return null;
		return parts[1];//return email..
	}
	
	protected Rainbow.Security.User GetRainbowUser(string email)
	{
		Rainbow.Security.UsersDB db=new UsersDB();
		using(SqlDataReader reader=db.GetSingleUser(email,PortalID))
		{
			if(!reader.Read())
				return null;

			return new Rainbow.Security.User(reader["Name"]+"|"+reader["Email"]+"|"+reader["UserId"]);
		}
	}

	public override AppChatIdentity GetLogonIdentity()
	{
		string uniquename=GetUserUniqueName();
		if(uniquename==null)
			return null;
		Rainbow.Security.User user=GetRainbowUser(uniquename);
		if(user==null)
			return null;

		return new AppChatIdentity(user.Name, false, ToUserId(uniquename), HttpContext.Current.Request.UserHostAddress);
	}

	public override string  FindUserLoginName(string nickName)
	{
		using(System.Data.SqlClient.SqlConnection conn=new System.Data.SqlClient.SqlConnection(GetConnectionString()))
		{
			using(System.Data.SqlClient.SqlCommand cmd=new System.Data.SqlClient.SqlCommand("SELECT Email FROM rb_Users WHERE Name=@name",conn))
			{
				System.Data.SqlClient.SqlParameter pusername=new System.Data.SqlClient.SqlParameter("@name",System.Data.SqlDbType.NVarChar,50);
				pusername.Value=nickName;
				cmd.Parameters.Add(pusername);

				conn.Open();
				using(System.Data.SqlClient.SqlDataReader sdr=cmd.ExecuteReader())
				{
					if(!sdr.Read())
						return null;
					return sdr.GetString(0);
				}
			}
		}
	}
	public override bool  GetUserInfo(string loginName, ref string nickName, ref bool isAdmin)
	{
		Rainbow.Security.User user=GetRainbowUser(loginName);
		if(user==null)return false;
		nickName=user.Name;
		string[] roles=new UsersDB().GetRoles(user.Email,PortalID);
		isAdmin=Array.IndexOf(roles,"Admins")!=-1;
		return true;
	}

	public override bool ValidateUser(string username, string password)
	{
		if(username==null)return false;

		string email=username;

		Rainbow.Security.User u=new UsersDB().Login(email,password,PortalID);
		if(u==null)
		{
			return false;
		}

		string unique=u.Name+"|"+u.Email+"|"+u.ID;
		unique=unique.ToLower();


		return true;
	}
}


</script>